

#include "header.fx"

float4x4 g_WorldViewProj : WORLDVIEWPROJ;
float3 LightDir; //transform into model coordinate
float3 GrassColor;

struct VS_INPUT
{
    float3 pos        : POSITION;
    float3 normal     : NORMAL;
    float3 color      : COLOR0;
    float2 uv0        : TEXCOORD0;
};

struct VS_OUTPUT
{
    float4 pos        : POSITION;
    float4 color      : COLOR0;
    float2 uv0        : TEXCOORD0;
};

VS_OUTPUT VSMain(VS_INPUT input)
{
	VS_OUTPUT output;
    
	float3 pos       = input.pos;
	float3 normal    = input.normal * float3(2/255.0, 2/255.0, 2/255.0) - float3(1.0, 1.0, 1.0);
	float2 uv0 = input.uv0 * float2(1.0/255.0, 1.0/255.0);
	float3 color = input.color * float3(1.0/255.0, 1.0/255.0, 1.0/255.0);

	output.pos = mul(float4(pos,1.0), g_WorldViewProj);
	float lt = max(0, dot(LightDir, normal)) * 0.5 + 0.5;
	output.color = float4(GrassColor.rgb*lt*color, 1.0);
	output.uv0 = uv0;

	return output;
}
