

#include "header.fx"

float4x4 g_WorldViewProj : WORLDVIEWPROJ;

float   g_SkyHeight;
float   g_DayTime;
float3  g_SunDirect;
float4  g_SunColor;


struct VS_INPUT
{
    float3 pos        : POSITION;
    float3 normal        : NORMAL;
    float2 staruv        : TEXCOORD0;
};

struct VS_OUTPUT
{
	float4 position : POSITION;
	float4 diffuse : COLOR0;
	float2 texcoord0 : TEXCOORD0;
	float2 texcoord1 : TEXCOORD1;
};

VS_OUTPUT VSMain(VS_INPUT input)
{
	VS_OUTPUT output;

	output.position = mul(float4(input.pos+g_EyePos,1.0), g_WorldViewProj);

	float t = (dot(g_SunDirect, input.normal) + 1.1f) * 0.5;
	output.diffuse.rgb = t * t * g_SunColor.rgb;
	output.diffuse.a = g_SunColor.a;
	output.texcoord0 = float2(g_DayTime, 1.0 - input.pos.y/g_SkyHeight);
	output.texcoord1 = input.staruv;
	
	return output;
}
